unit uvates;

{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, usalasdejuego, utrazosxy, uestados, uversiones;

type

  { TVatesForm }

  TVatesForm = class(TForm)
    btCargarSala: TButton;
    btEstadoActual: TButton;
    btCargarCF_Base: TButton;
    cbObligarDisponibilidad_1_Sim: TCheckBox;
    cbObligarInicioCronicaIncierto_1_sim: TCheckBox;
    eArchiSala: TEdit;
    eMaxNItersSim: TLabeledEdit;
    eSemillaAleatoriaSim: TLabeledEdit;
    GroupBox1: TGroupBox;
    eNCronicasSim: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    procedure btCargarCF_BaseClick(Sender: TObject);
    procedure btCargarSalaClick(Sender: TObject);
    procedure btEstadoActualClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    sala: TSalaDeJuego;

    procedure CargarSala(archiSala, nombre_escenario_activo: string);
    procedure cargarSala_( nombre_escenario_activo: string );
  public
    { public declarations }
  end;

var
  VatesForm: TVatesForm;

implementation

{$R *.lfm}

{ TVatesForm }

procedure TVatesForm.CargarSala(archiSala, nombre_escenario_activo: string);
begin
  if Sala <> nil then
  begin
    Sala.Free;
    sala := nil;
  end;

  try
    sala:= TSalaDeJuego.cargarSala( archiSala, nombre_escenario_activo, True );
  except
    on E: Exception do
    begin
      ShowMessage('CargarSala, Error:' + #13 + E.Message);
      raise;
    end;
  end;
end;




procedure TVatesForm.cargarSala_( nombre_escenario_activo: string );
var
  carpetaSala: string;
begin
  try
    carpetaSala := extractFilePath(eArchiSala.Text);
    chdir(carpetaSala);
    CargarSala(eArchiSala.Text, nombre_escenario_activo );
  except
    begin
      MessageDlg('Error cargando la Sala', mtError, [mbOK], 0);
 //     PostQuitMessage(0);
      exit;
    end;
  end;

  ENCronicasSim.Text := IntToStr(sala.globs.NCronicasSim);
  cbObligarDisponibilidad_1_Sim.Checked := sala.globs.ObligarDisponibilidad_1_Sim;
  cbObligarInicioCronicaIncierto_1_sim.Checked := sala.globs.ObligarInicioCronicaIncierto_1_Sim;
  eMaxNItersSim.Text := IntToStr(sala.globs.NMAX_ITERACIONESDELPASO_SIM);
  eSemillaAleatoriaSim.Text := IntToStr(sala.globs.semilla_inicial_sim);

end;


procedure TVatesForm.btCargarSalaClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    eArchiSala.Text := OpenDialog1.FileName;
    CargarSala_('__principal__');
    self.Caption := 'SimSEE ' + eArchiSala.Text;
  end;
end;

procedure TVatesForm.btEstadoActualClick(Sender: TObject);
begin

end;

procedure TVatesForm.btCargarCF_BaseClick(Sender: TObject);
begin
  if sala.globs.CF <> nil then
     sala.globs.CF.Free;


   Sala.globs.CF := TAdminEstados_SobreMuestreado.CreateLoadFromArchi(
    sala.dirResultadosCorrida + 'CFBase_'+ sala.EscenarioActivo.nombre+'.bin',
    sala.globs.fechaIniSim.dt, sala.globs.fechaFinSim.dt, sala.globs.HorasDelPaso );
end;

procedure TVatesForm.FormCreate(Sender: TObject);
begin
  self.caption:= 'Vates (c)Proyecto ANII-FSE-1-2011-1-6552  (IIE-FING-UDELAR-FJR) (VER_' + uversiones.vSimSEESimulador_ + ')';
end;


end.

